#ifndef _H_CRYPTO
#define _H_CRYPTO

#include <openssl/rand.h>
#include <openssl/pem.h>
#include <openssl/bn.h>
#include <openssl/dsa.h>

DSA *import_public_key (FILE *f);
DSA *import_private_key (FILE *f, pam_handle_t *pamh);
int valid_dsa_keys (DSA *private, DSA *public);
int prompt_for_password (char *passphrase, int size, int rwflag, void *u);

#endif
