#include "usbadm.h"
#include <device.h>
#include <parser.h>

int addserial (int ac, char **av)
{
	char *serial = NULL;
	FILE *f;

	if (ac >= 3)
		serial = av[2];

	if (!serial) {
		char *file, *tmp;

		while ((file = find_proc_file ())) {
			if (!(f = fopen (file, "r"))) {
				free (file);
				continue;
			}
			printf ("[+] procfile: %s\n", file);

			serial = get_param(f, "Serial Number", ':');

			if (serial &&
			    !strcmp (serial, "None")) {
				free (serial);
				serial = NULL;
			}

			if (!serial) {
				printf ("[-] serial number: none\n");

				/* fall back to GUID */
				if (!(serial = get_param (f, "GUID", ':'))) {
					fclose (f);
					free (file);
					printf ("[-] GUID: none\n");
					continue;
				}

				printf ("[+] GUID: %s\n", serial);
				tmp = insert_before ("{G} ", serial);
				free (serial);
				serial = tmp;
			} else {
				printf ("[+] serial number: %s\n", serial);
				tmp = insert_before ("{S} ", serial);
				free (serial);
				serial = tmp;
			}

			if (!serial) {
				fclose (f);
				free (file);
				break;
			}

			printf ("[+] auth number: %s\n", serial);

			if (!check_param (f, "Attached", "Yes", ':')) {
				fclose (f);
				free (file);
				free (serial);
				serial = NULL;
				printf ("[-] attached: no\n");
				continue;
			}
			fclose (f);
			free (file);
			printf ("[+] attached: yes\n");
			break;
		}
	}

	if (!serial) {
		printf ("[-] Cannot retrieve the serial number\n");
		return 1;
	}

	if (!(f = fopen (usb_conf.snfile, "a"))) {
		printf ("cannot open file %s\n", usb_conf.snfile);
		free (serial);
		return 1;
	}

	printf ("[!] Allowing serial number %s...", serial);
	fflush (stdout);

	if (fputs (serial, f) == EOF) {
		printf ("[-] cannot write file %s\n", usb_conf.snfile);
		fclose (f);
		free (serial);
		return 1;
	}
	fputc ('\n', f);
	fclose (f);
	free (serial);

	printf ("done.\n");

	return 0;
}
